
/**
 * Module dependencies.
 */

var express = require('../..')
  , fs = require('fs')
  , md = require('marked').parse;

var app = module.exports = express();

// register .md as an engine in express view system

app.engine('md', function(path, options, fn){
  fs.readFile(path, 'utf8', function(err, str){
    if (err) return fn(err);
    try {
      var html = md(str);
      html = html.replace(/\{([^}]+)\}/g, function(_, name){
        return options[name] || '';
      })
      fn(null, html);
    } catch(err) {
      fn(err);
    }
  });
})

app.set('views', __dirname + '/views');

// make it the default so we dont need .md
app.set('view engine', 'md');

app.get('/', function(req, res){
  res.render('index', { title: 'Markdown Example' });
})

app.get('/fail', function(req, res){
  res.render('missing', { title: 'Markdown Example' });
})

if (!module.parent) {
  app.listen(3000);
  console.log('Express started on port 3000');
}
